/* This file is part of cqual.
   Copyright (C) 2000-2003 The Regents of the University of California.

cqual is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

cqual is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with cqual; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. */

#ifndef CQUAL_H
#define CQUAL_H

#include "cqual-stdint.h"
#include "libqual.h"
#include "bitset.h"
#include "bool.h"
#include "buffer.h"
#include "regions.h"
#include "linkage.h"

EXTERN_C_BEGIN

/* If you use fail_loc, you must give a 3rd argument!  Pass 0 if you
   don't need anything there. */
#define fail_loc(l, s, args...) fail("(at %s:%ld) " s, ((l)->filename), ((l)->lineno), args)

/* If you use user_error_loc, you must give a 3rd argument!  Pass 0 if you
   don't need anything there. */
#define user_error_loc(l, s, args...) user_error("(at %s:%ld) " s, ((l)->filename), ((l)->lineno), args)

EXTERN_C_END

#endif
