/* This file is part of cqual.
   Copyright (C) 2004 University of Maryland

cqual is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

cqual is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with cqual; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. */

package libqual;

public class Native {
    private static native void initCQual(String latticePathArg);
    public static native void finishCQual();
    static {
        System.loadLibrary("qual");
	//        initCQual(JqualPlugin.latticePath);
    }

    //----------------------------------------------------------------
    // Qualifiers
    //----------------------------------------------------------------
    public static native int makeQvar(String name, int locationIndex, boolean preferred, boolean global);
    public static native int makeFreshQvar(String name, int locationIndex);
    public static native boolean variableQual(int locationIndex);
    public static native boolean constantQual(int locationIndex);
    public static native int findQual(String name);
    public static native String nameQual(int locationIndex);

    //----------------------------------------------------------------
    // Qualified Types
    //----------------------------------------------------------------
    public static native int mkqtypeBool(int index);
    public static native int mkqtypeChar(int index);
    public static native int mkqtypeInt(int index);
    public static native int mkqtypeLong(int index);
    public static native int mkqtypeFloat(int index);
    public static native int mkqtypeDouble(int index);
    public static native int mkqtypeVoid(int index);
    public static native int nativeGetNativeLocationFromQtype(int qtypeIndex);
    
    //----------------------------------------------------------------
    // Constraints
    //----------------------------------------------------------------
    public static native boolean mkeqQtype(int locationIndex, int leftQTIndex, int rightQTIndex, String errorMessage);
    public static native boolean mkleqQtype(int locationIndex, int leftQTIndex, int rightQTIndex, String errorMessage);
    public static native void mkeqQual(int locationIndex, int leftQualIndex, int rightQualIndex, String errorMessage);
    public static native void mkleqQual(int locationIndex, int leftQualIndex, int rightQualIndex, String errorMessage);

    //----------------------------------------------------------------
    // Locations
    //----------------------------------------------------------------
    public static native int allocLocation();
    public static native long getLineFromLocation(int locationIndex);
    public static native long getFilePositionFromLocation(int locationIndex);
    public static native String getFileNameFromLocation(int locationIndex);
    public static native void setLineForLocation(int nativeIndex, long line);
    public static native void setFilePositionForLocation(int nativeIndex, long fp);
    public static native void setFileNameForLocation(int nativeIndex, String name);
}
