/* This file is part of cqual.
   Copyright (C) 2000-2003 The Regents of the University of California.

cqual is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

cqual is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with cqual; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. */

#ifndef QUAL_FLAGS_H
#define QUAL_FLAGS_H

/* -f flags.  */

#include "linkage.h"
#include "bool.h"

EXTERN_C_BEGIN

/* Treat warnings as errors.  -Werror.  */
extern int warnings_are_errors;

/* True if we should print out the qualifier constraint graph in dot
   form. */
extern int flag_print_quals_graph;

/* True if we should display names in an ugly way so that you can tell
   different versions of the same name apart. */
extern int flag_ugly;

/* When this flag is TRUE, the type constraint solver is only required
   to compute the bounds on type variables with inconsistent bounds.
   This optimization can provide a big speedup. */
extern int flag_errors_only;

/* When this flag is true, print out an explanation for each of the 
   errors, a la PAM mode.  */
extern int flag_explain_errors;

/* Don't filter errors */
extern int flag_all_errors;

/* When this flag is TRUE, the type inference engine should perform a
   context-summary analysis in addition to the standard
   context-independent analysis. */
extern int flag_context_summary;

EXTERN_C_END

#endif
