/**
 *  This example will produce a warning under field-insensitive analysis,
 *  but not under full- or selective-field-sensitive analysis.
 *  
 *  Analysis must be context sensitive for field sensitivity to have
 *  an effect. Otherwise all object fields will be merged at the
 *  constructor return.
 */
public class FSExample {
	
	static class C {
		/**@FieldSensitive*/int f;
	}
	
	static void main(){
		C o = new C();
		C p = new C();
		
		/**@qual tainted**/  int t = 17;
		/**@qual untainted**/int u;
		p.f = t;
		u = o.f; 
	}
}
